# All files / src/node-obfuscators FunctionDeclarationObfuscator.ts

100% Statements 19/19
100% Branches 4/4
100% Functions 2/2
100% Lines 19/19

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    781x

    1x

    1x
    1x
    1x
    1x

    1x

    2028x

    2028x

    2028x
    10x

    2018x
    2018x

    2018x
    2018x

    2018x

    2018x

    269189x
    74607x

     import * as estraverse from 'estraverse';
    import * as ESTree from 'estree';

    import { ICustomNode } from '../interfaces/custom-nodes/ICustomNode';
    import { IOptions } from '../interfaces/IOptions';

    import { NodeType } from '../enums/NodeType';

    import { AbstractNodeObfuscator } from './AbstractNodeObfuscator';
    import { IdentifierReplacer } from './replacers/IdentifierReplacer';
    import { Nodes } from '../Nodes';
    import { NodeUtils } from '../NodeUtils';

    /**
     * replaces:
     *     function foo () { //... };
     *     foo();
     *
     * on:
     *     function _0x12d45f () { //... };
     *     _0x12d45f();
     */
    export class FunctionDeclarationObfuscator extends AbstractNodeObfuscator {
        /**
         * @type {IdentifierReplacer}
         */
        private identifierReplacer: IdentifierReplacer;

        /**
         * @param nodes
         * @param options
         */
        constructor(nodes: Map <string, ICustomNode>, options: IOptions) {
            super(nodes, options);

            this.identifierReplacer = new IdentifierReplacer(this.nodes, this.options);
        }

        /**
         * @param functionDeclarationNode
         * @param parentNode
         */
        public obfuscateNode (functionDeclarationNode: ESTree.FunctionDeclaration, parentNode: ESTree.Node): void {
            if (parentNode.type === NodeType.Program) {
                return;
            }

            this.storeFunctionName(functionDeclarationNode);
            this.replaceFunctionName(functionDeclarationNode);
        }

        /**
         * @param functionDeclarationNode
         */
        private storeFunctionName (functionDeclarationNode: ESTree.FunctionDeclaration): void {
            NodeUtils.typedReplace(functionDeclarationNode.id, NodeType.Identifier, {
                enter: (node: ESTree.Identifier) => this.identifierReplacer.storeNames(node.name)
            });
        }

        /**
         * @param functionDeclarationNode
         */
        private replaceFunctionName (functionDeclarationNode: ESTree.FunctionDeclaration): void {
            let scopeNode: ESTree.Node = NodeUtils.getBlockScopeOfNode(
                functionDeclarationNode
            );

            estraverse.replace(scopeNode, {
                enter: (node: ESTree.Node, parentNode: ESTree.Node): any => {
                    if (Nodes.isReplaceableIdentifierNode(node, parentNode)) {
                        node.name = this.identifierReplacer.replace(node.name);
                    }
                }
            });
        }
    }